aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--[-rwxr-xr-x]target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh18
1 files changed, 18 insertions, 0 deletions
diff --git a/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
index f1dc81f7c9..5d25c20ad7 100755..100644
--- a/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
+++ b/target/linux/ipq40xx/base-files/lib/upgrade/linksys.sh
@@ -47,6 +47,14 @@ linksys_get_target_firmware() {
esac
}
+linksys_is_factory_image() {
+ local board=$(board_name)
+ board=${board##*,}
+
+ # check matching footer signature
+ tail -c 256 $1 | grep -q -i "\.LINKSYS\.........${board}"
+}
+
platform_do_upgrade_linksys() {
local magic_long="$(get_magic_long "$1")"
@@ -99,4 +107,14 @@ platform_do_upgrade_linksys() {
echo "writing \"$1\" image to \"$part_label\""
get_image "$1" | mtd write - "$part_label"
}
+
+ [ "$magic_long" = "d00dfeed" ] && {
+ if ! linksys_is_factory_image "$1"; then
+ echo "factory image doesn't match device"
+ return 1
+ fi
+
+ echo "writing \"$1\" factory image to \"$part_label\""
+ get_image "$1" | mtd -e "$part_label" write - "$part_label"
+ }
}